from typing import Any

from ..complexities import (
    ComplexitiesDict,
    constant,
    linear_to_len,
)


frozenset_complexities: ComplexitiesDict = {
    '__and__': linear_to_len,
    '__class__': constant,
    '__class_getitem__': constant,
    '__contains__': constant,
    '__delattr__': constant,
    '__dir__': constant,
    '__doc__': constant,
    '__eq__': linear_to_len,
    '__format__': constant,
    '__ge__': linear_to_len,
    '__getattribute__': constant,
    '__gt__': linear_to_len,
    '__hash__': linear_to_len,
    '__init__': linear_to_len,
    '__init_subclass__': constant,
    '__iter__': constant,
    '__le__': linear_to_len,
    '__len__': constant,
    '__lt__': linear_to_len,
    '__ne__': linear_to_len,
    '__new__': constant,
    '__or__': linear_to_len,
    '__rand__': linear_to_len,
    '__reduce__': constant,
    '__reduce_ex__': constant,
    '__repr__': linear_to_len,
    '__ror__': linear_to_len,
    '__rsub__': linear_to_len,
    '__rxor__': linear_to_len,
    '__setattr__': constant,
    '__sizeof__': constant,
    '__str__': linear_to_len,
    '__sub__': linear_to_len,
    '__subclasshook__': constant,
    '__xor__': linear_to_len,
    'copy': constant,
    'difference': linear_to_len,
    'intersection': linear_to_len,
    'isdisjoint': linear_to_len,
    'issubset': linear_to_len,
    'issuperset': linear_to_len,
    'symmetric_difference': linear_to_len,
    'union': linear_to_len,
}
