from typing import Any

from ..complexities import (
    ComplexitiesDict,
    constant,
    linear_to_len,
)


memoryview_complexities: ComplexitiesDict = {
    '__class__': constant,
    '__delattr__': constant,
    '__delitem__': constant,
    '__dir__': constant,
    '__doc__': constant,
    '__enter__': constant,
    '__eq__': linear_to_len,
    '__exit__': constant,
    '__format__': constant,
    '__ge__': linear_to_len,
    '__getattribute__': constant,
    '__getitem__': constant,
    '__gt__': linear_to_len,
    '__init__': constant,
    '__init_subclass__': constant,
    '__iter__': constant,
    '__le__': linear_to_len,
    '__len__': constant,
    '__lt__': linear_to_len,
    '__ne__': linear_to_len,
    '__new__': constant,
    '__reduce__': constant,
    '__reduce_ex__': constant,
    '__repr__': constant,
    '__setattr__': constant,
    '__setitem__': constant,
    '__sizeof__': constant,
    '__str__': linear_to_len,
    '__subclasshook__': constant,
    'c_contiguous': constant,
    'cast': constant,
    'contiguous': constant,
    'f_contiguous': constant,
    'format': constant,
    'hex': linear_to_len,
    'itemsize': constant,
    'nbytes': constant,
    'ndim': constant,
    'obj': constant,
    'readonly': constant,
    'release': constant,
    'shape': constant,
    'strides': constant,
    'suboffsets': constant,
    'tobytes': linear_to_len,
    'tolist': linear_to_len,
    'toreadonly': constant,
}
